
// initialise when document is loaded
$(function() {

	// global error handler
	// http://stackoverflow.com/questions/10197895/ipad-javascript-error-not-helpful?lq=1
	window.onerror = function (error, page, line, chr) {

		tma.log({
			title: "error in window.onerror",
			details: {
				error: error,
				page: page,	//useless
				line: line,	//useless
				chr: chr,	//useless
			}
		});

	};

	var w = $('#init-progress-frame').innerWidth();
	$(tma).on('tmaProgress', function(e, percent, msg) {

		$('#init-progress').width( parseInt( w * percent / 100) );
		$('#init-progress-msg').text(msg);

	});

	$(tma).on('tmaReady', function() {

		tma.log('tma is ready');

		document.title = "WebControl - " + tma.config.pvrname + ((tma.config.mock) ? ' (mock)' : '');
		
		if (!tma.initStatus.logos) {
			
			new jkqAlert({
				title:	tma.i18.dialog_title_error,
				text:	tma.i18.error_init_logos
			}).confirm();
			
		}

		/**
		 * let modules insert their register tabs
		 */
		tma.fn.runFeature('appendMenuTab');

		$('P#tma_config').html(
				'WebControl: ' + tma.config.tma1ver + '<br>' +
				'PVR: ' + tma.config.device + (tma.config.utftoppy ? ' (utf)' : ' (non-utf)') + '<br>' +
				tma.i18.language
		);

		// startpage
		var startpage = '#' + tma.localSetting('startpage', 'configpage');
		if ( $( startpage ).length ) {
			$( startpage ).click();
		} else {
			$( 'UL#MainMenu > LI:first' ).click();
		}

	});

	tma.init();

});

/**
 * Utilities:
 */

/**
 * returns the html string for event start/end/duration
 *
 * @param {Date}	event_start
 * @param {Date}	event_end
 * @param {Number}	event_duration		in minutes
 * @param {Number}	infile_duration		(optional) default = event_duration
 * @returns {String}
 */
function getEventDateString(event_start, event_end, event_duration, infile_duration) {

	if (!infile_duration) infile_duration = event_duration;

	var s = '<h3>' +
				tma.date( tma.i18.eventstart_fmt, event_start) +
				' - ' + tma.date( 'H:i', event_end) +
				' &nbsp; ' +
				((event_duration != infile_duration) ?
						"{0}/{1}".format(infile_duration, event_duration) :
						event_duration) +
				' min' +
			'</h3>';

	return s;

}

/**
 * returns the html string for a genre and parental text
 *
 * @param {Object}	event		event object
 * @returns {String}
 */
function getGenreAndParentalString(event) {

	var s = '';

	if ((event.genre_text) || (event.parental_text)) {
		s =	'<h4>' +
				( (event.genre_text) ? event.genre_text : '' ) +
				( (event.parental_text) ? ' (' + event.parental_text + ')' : '' ) +
			'</h4>';
	}

	return s;

}
