function tmaFeature(name) {

	this.STATE_STOP = 0;
	this.STATE_RUN = 1;
	this.STATE_PAUSE = 2;

	var state = this.STATE_STOP;
	var nextObjIndex = 0;
	var handlerObjects = [];
	var handlerArgs = [];

	this.name = name;
	this.result = undefined;

	/**
	 * add a modul handler to the chain
	 *
	 * @param {Object}		handlerObj
	 * @param {Function}	extHandler
	 */
	this.addFeature = function(handlerObj) {

		handlerObjects.push(handlerObj);

	};

	this.start = function(args) {

		if (tma.debug) tma.log('featureChain.start(' + this.name + ')');

		if (tma.debug) tma.log('featureChain.start: typeof args=' + typeof(args));
		if (tma.debug) tma.log('featureChain.start: args.length=' + args.length);

		// building new array this way, because iPad1 has problems else
		handlerArgs = new Array();
		handlerArgs.push(this);
		if (args) {
			for (var i=0; i<args.length; i++) {
				handlerArgs.push(args[i]);
			}
		}

		if (tma.debug) tma.log('featureChain.start: typeof handlerArgs=' + typeof(handlerArgs));
		if (tma.debug) tma.log('featureChain.start: handlerArgs.length=' + handlerArgs.length);
		if (tma.debug)
			for (var n=0; n<handlerArgs.length; n++) {
				tma.log('featureChain.start: typeof handlerArgs[' + n + ']=' + typeof(handlerArgs[n]));
			}
		nextObjIndex = 0;
		state = this.STATE_RUN;

		return this.run();

	};

	this.stop = function() {

		nextObjIndex = 0;
		state = this.STATE_STOP;

	};

	this.pause = function() {

		state = this.STATE_PAUSE;

	};

	this.run = function() {

		if (state == this.STATE_PAUSE) {
			// continue
			state = this.STATE_RUN;
		}

		while ( (nextObjIndex < handlerObjects.length) && (state == this.STATE_RUN) ) {

			if (tma.debug) tma.log('featureChain.run(' + this.name + ') [' + nextObjIndex + ']');

			var obj = handlerObjects[nextObjIndex];
			this.result = obj[this.name].apply(obj, handlerArgs);

			nextObjIndex++;

		}

		if (nextObjIndex == handlerObjects.length) {
			this.stop();
		}

		if (state == this.STATE_STOP) {
			return this.result;
		}

	};

}
