/**
 * Directory selection modul
 */
tma.registerModule( dirselector );
function dirselector() {

	/**
	 * IMPORTANT: the modules name; equal to directory and script file name
	 */
	this.name = 'dirselector';

	var self = this;

	var dirWindow = new jkqWindow();
	dirWindow.width = 300;

	/**
	 * initialize module
	 */
	this.setup = function() {

		// register tmaFeatures
		tma.fn.addFeature( this, 'selectDirectory' );

		return this.parent().setup();

	};

	/**
	 * show directory tree in a window
	 *
	 * @param {tmaFeature}	f
	 * @param {String}		root		tree root
	 * @param {Function}	onSelect	callback function(path), that is called when a directory is selected
	 */
	this.selectDirectory = function(f, root, onSelect) {

		/**
		 * this method will handle the feature,
		 * so stop the feature chain
		 */
		f.stop();

		this.init().done(function() {

			dirWindow.showModal();
			dirWindow.setTitle( self.i18.window_caption );

			tma.apiTreeFiles(root).done(function() {

				var html = '';

				function addDirs(dirs) {

					$.each(dirs, function(nr, dir) {

						html += '<div class="dir_ctx">';
						html += '<div class="dir_name" path="' + dir.path + '/' + dir.name + '">' + dir.name + '</div>';
						html += '<div class="dir_sub">';
						if (dir.dirs.length) addDirs(dir.dirs);
						html += '</div>';
						html += '</div>';

					});

				}

				addDirs(tma.directories);

				dirWindow.container.find('DIV.jkqWindowContent')
				.html(html)
				.on('click', 'DIV.dir_name', function() {

					if (onSelect) {
						onSelect( $(this).attr('path') );
					}
					dirWindow.close();

				});

				dirWindow.adjustPos();

			}).fail(function(xhr, errorType, error) {

				dirWindow.container.find('DIV.jkqWindowContent').html( self.i18.load_error.format(error) );

			});

			dirWindow.container.find('DIV.jkqWindowContent').html('<img src="css/img/wait.gif">');
			dirWindow.adjustPos();

		});

	};

}
