/**
 * log module
 */
tma.registerModule( logpage );
logpage.prototype = new tmaModule();
function logpage() {

	/**
	 * IMPORTANT: the modules name; equal to directory and script file name
	 */
	this.name = 'logpage';

	var self = this;

	var log = '';

	/**
	 * initialize module
	 */
	this.setup = function() {

		// register tmaFeatures
		tma.fn.addFeature( this, 'appendMenuTab' );

		// register tma event handler
		$(tma).on( 'tmaLog', function( e, msg ) {

			self.appendLog(msg);

		});

		return this.parent().setup();

	};

	/**
	 * append tab to menu
	 *
	 * @param {tmaFeature}	f
	 */
	this.appendMenuTab = function( f ) {

		/** @returns MenuManager */
		var menu;
		if (menu = tma.fn.runFeature('getMenu', ['MainMenu'])) {

			menu.addPage( this, this.i18.menu_caption );
			//menu.disableItem( this.name );

			/*/ get log from tma
			var logs = tma.getLog();
			$.each(logs, function(i, msg) {
				self.appendLog(msg);
			});*/

		}

	};

	/**
	 * display the log content
	 */
	this.show = function() {

		this.init().done(function() {

			$('#content').append(
					'<div id="logpage">' +
						'<h3>Log</h3>' +
						'<div id="tmalog">' +
							log +
						'</div>' +
					'</div>'
			);

			$('#tma-status').hide();

		});

	};

	/**
	 * this page gets removed, so display #tma-status again
	 */
	this.cleanup = function() {

		$('#tma-status').show();

	};

	/**
	 * append a Log message
	 *
	 * @param {String} msg
	 */
	this.appendLog = function(msg) {

		log += '<p>' + msg.replace(/\n+/g, '<br>') + '</p>';

		if ( !$.isEmptyObject(self.parentMenu) ) {
			self.parentMenu.enableItem( self.name );
		}

	};

};
